#include "stdafx.h"

#include "mpi.h"
#include <stdio.h>
#include <stdlib.h>

#include <math.h>

#include <windows.h>

#include <time.h>

///////////////////////////////////////////////////////////////////////////
// Konstanten
///////////////////////////////////////////////////////////////////////////


#define root 0




int main(int argc, char *argv[])
{
    int myPid;
    int numprocs;
	int j, n;
	unsigned long  start, teiler, grenze, rest, zahl; 
	double d;
	int l_prim, g_prim;
	double t1, t2;

	
    MPI_Init(&argc,&argv);

	   // Anzahl der Prozesse
    MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
   
	   // meine eigene ID
	MPI_Comm_rank(MPI_COMM_WORLD,&myPid);
    
	
	
	if (myPid == 0)
	{    
		n = 17;	// 131072-1
		n = 31;	// 2147483648-1 = 2147483647

		zahl =1;
		for (j=0; j<n; j++) {
			zahl = zahl * 2;
			if (myPid==root) printf("2^i: %u\n",zahl);
		}
		zahl = zahl - 1;
		if (myPid==root) 
			printf("Ausgangszahl: 2^n-1: %u\n",zahl);
	}
    // An alle Client und Master eine Botschaft senden, wieviele n
    MPI_Bcast(&zahl, 1, MPI_LONG, 0, MPI_COMM_WORLD);

	printf("myPid %d  N %u \n", myPid, zahl);

	// Bereiche aufteilen
	d = zahl;
	d = sqrt(d)+1;
	grenze=(unsigned long) d+1;
	start=3;
	if (myPid==root) {
		printf("Pid: %d\n   start %u\n   grenze %u\n\n\n", myPid, start, grenze);
	}
	for (j=1; j<=myPid; j++) {
		start+=2;
	}
	//i1=2;
	//i2=100;
	// prfe ob Primzahl
	l_prim=1; // zahl ist Primzahl
	teiler=start;
    t1 = MPI_Wtime();
	while (true) {
		rest = zahl % teiler;
		if (rest==0) {
			printf("Pid %d Keine Primzahl, Teiler: %d \n", myPid, teiler);
			l_prim=0;  // nun nicht mehr
			break;
		}
		for (j=0; j<numprocs; j++) {
			teiler+=2;
		}

		if (grenze < teiler) {
			break;
		}
		
	}
    t2 = MPI_Wtime();
	printf("Pid: %d   Zeit: %f\n",myPid, t2-t1);
	

	MPI_Reduce(&l_prim, &g_prim, numprocs, MPI_INT, MPI_SUM, root, MPI_COMM_WORLD);
	if (myPid==0) {
		if ( g_prim == numprocs) 
			printf("\n\nDie Zahl %ld ist eine Primzahl\n", zahl);
		else
			printf("\n\nDie Zahl %ld ist keine Primzahl\n", zahl);
	}

    MPI_Finalize();
	return 0;
}


// kernel32.lib user32.lib mpich.lib