#include "mpi.h"
#include <stdio.h>
#include <math.h>


#define MAX 4

// Maximum  wird SPALTENWEISE  gebildet  !!!!


// Bitte geben Sie IMMER vier Task an
// Bestimme pro Client das jeweilige Maximum

// Struktur fr die Information beider Werte
// Value UND Pid
struct MPIStruct {
		double value;
		int Pid;
};


void main(int argc, char *argv[])
{
    int myPid, i;
    int root = 0;
	int numprocs;
    
	  // Jeder Prozess hat n-Werte  Eingangswerte
	  // Es gibt k-Prozesse x n-Werte
	double dX[MAX]; // Eingangswerte

	  // Ziel pro Index den Maximalwert, in dOut
	double dY[MAX]; // "Berechnete Ausgangswerte"

	 // wird nur vom Rot verwendet
	int index[MAX];
	double dmax[MAX];           

	  // Variablen fr die Reduce-Anweisung
	struct MPIStruct local_in[MAX];
	struct MPIStruct g_out[MAX];

	
    MPI_Init(&argc,&argv);

	   // Anzahl der Prozesse
    MPI_Comm_size(MPI_COMM_WORLD,&numprocs);

	if ( numprocs != MAX ){
      printf("Bitte genau %d Prozesse starten\n", MAX);
      MPI_Finalize();
	  return;
	}
    
	   // meine eigene ID
	MPI_Comm_rank(MPI_COMM_WORLD,&myPid);
    
	  // init
	for (i=0; i<MAX; i++) {
		dX[i] = 0;
		dY[i] = 0;
	}

      // Hier sollte aus einer Datei gelesen werden, pro Pid !
	switch (myPid) {
		case 0:
	    	dX[0] = 1;
	    	dX[1] = 2;
	    	dX[2] = 3;
	    	dX[3] = 33;
			break;
		case 1:
	    	dX[0] = 114;
	    	dX[1] = 0;
	    	dX[2] = -1;
			dX[3] = 1;
			break;
		case 2:
	    	dX[0] = 23;
	    	dX[1] = 1;
	    	dX[2] = 11;
	    	dX[3] = 14;
			break;
		case 3:
	    	dX[0] = 1;
	    	dX[1] = -2;
	    	dX[2] = 12;
	    	dX[3] = -7;
			break;
	}

	  // Berechnung dy = f(dx)
	for (i=0; i<MAX; i++) {
		dY[i] = dX[i] +1;
	}

	  // speichern in das lokale Feld local_in
	for (i=0; i<MAX; i++) {
		local_in[i].value = dY[i];
		local_in[i].Pid = myPid;
		printf("   Pid: %d   index: %d    Y: %f\n", myPid, i, dY[i]);			
	}
	

	// MPI_Barrier(MPI_COMM_WORLD);  // nicht notwendig, da reduce automaisch wartet

	 // Aufruf der reduce-Anweisung
	MPI_Reduce(local_in, g_out, MAX, MPI_DOUBLE_INT, MPI_MAXLOC, root, MPI_COMM_WORLD);

	if (myPid  ==  root) {
		for (i=0; i<MAX; i++) {
			dmax[i] = g_out[i].value;
			index[i] = g_out[i].Pid;
			printf("Index: %d   Pid: %d   Maxwert: %f\n", i, index[i], dmax[i]);			
		} // for
		
	}  // if

	

    MPI_Finalize();
}

/*
Ergebnisse:

Index: 0   Pid: 1   Maxwert: 5.000000
Index: 1   Pid: 2   Maxwert: 7.000000
Index: 2   Pid: 0   Maxwert: 4.000000


*/
