#include "mpi.h"
#include <stdio.h>
#include <math.h>

#define MAXCLIENT 4
#define MAX 3
#define root 0

// Bitte immer vier Tasks angeben

// Programm zur Berechnung einer Maxtrix Vektor Multiplikation
// Version 2
/*
(  a  b  c )     ( x )
(  d  e  f )  *  ( y )
(  g  h  i )     ( z )
*/

// Version bergibt jeweils die Zeile an einem Client
// Version bergibt danach den Vektor b

// Erweiterung mit Broadcast
// Kein Reduce-Befehl


void main(int argc, char *argv[])
{
    int Pid, numprocs;
	int i;
	
	double l_mat[MAX];
	double mat[MAX*MAX]= { 1,2,3,4,5,6,7,8,9 };
	double b[MAX];

		// nur von Root bentigt
	double summe;
	double erg[MAX];

	// Status
	MPI_Status status;
	
    MPI_Init(&argc,&argv);

	   // Anzahl der Prozesse
    MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
	if (numprocs != MAXCLIENT) {
		printf("Bitte immer %d Client definieren\n",MAXCLIENT);
		return;
	}
    
	   // meine eigene ID
	MPI_Comm_rank(MPI_COMM_WORLD,&Pid);

	// Root sendet Maxtrix zeilenweise
	// Root sendet Vektor B
	if (Pid  ==  root) {
		// Root rechnet NICHT !!
		b[0]= 10;	b[1]= 11;	b[2]= 12; // Init nur im Root
		
		MPI_Send( &mat[0], 3, MPI_DOUBLE, 1, 0, MPI_COMM_WORLD);
		MPI_Send( &mat[3], 3, MPI_DOUBLE, 2, 0, MPI_COMM_WORLD);
		MPI_Send( &mat[6], 3, MPI_DOUBLE, 3, 0, MPI_COMM_WORLD);

			// neu, sendet
		MPI_Bcast( b, 3, MPI_DOUBLE, 0, MPI_COMM_WORLD);

		MPI_Recv( &erg[0], 1, MPI_DOUBLE, 1, 0, MPI_COMM_WORLD, &status);
		MPI_Recv( &erg[1], 1, MPI_DOUBLE, 2, 0, MPI_COMM_WORLD, &status);
		MPI_Recv( &erg[2], 1, MPI_DOUBLE, 3, 0, MPI_COMM_WORLD, &status);
	}
	else {
		MPI_Recv( l_mat, 3, MPI_DOUBLE, 
			root, 0, MPI_COMM_WORLD, &status);
			// neu, empfngt
		MPI_Bcast( b, 3, MPI_DOUBLE, 0, MPI_COMM_WORLD);
        printf("  Pid: %d\n", Pid);
		printf("  Pid: %d    mat(0): %f   mat(1): %f   mat(2): %f\n",
				   Pid, l_mat[0], l_mat[1], l_mat[2] );
		printf("  Pid: %d    b(0): %f   b(1): %f   b(2): %f\n",
				   Pid, b[0], b[1], b[2] );
		// Multiplikation
		summe=0.0;
		for (i=0; i<MAX; i++) {
			summe += l_mat[i]*b[i];
		}
		printf("  Pid: %d   summe: %f\n",Pid, summe);
		MPI_Send( &summe, 1, MPI_DOUBLE, root, 0, MPI_COMM_WORLD);

	}

/*
    MPI_Reduce(&mysum, &G_sum, 1, MPI_INT, MPI_SUM, 
		    0, MPI_COMM_WORLD);
*/
			
		  // nur Master gibt aus
    if (Pid == 0) {
		puts("");
		puts("Ergebnis:");
		for (i=0; i<MAX; i++) {
		  printf("Master: summe[%d] = %f\n", (i+1), erg[i]);
		}
	}
      

	MPI_Finalize();
}


/*

double TransportCosts[][cMkts] =
{ { 32.19, 47.29, 31.99, 19.11 },
  { 11.29, 22.49, 33.47, 17.29 },
  { 41.97, 22.09,  9.76, 22.55 }  };


*/