#include "mpi.h"
#include <stdio.h>
#include <math.h>

#define MAXCLIENT 4
#define MAX 3
#define root 0

// Bitte immer vier Tasks angeben

// Programm zur Berechnung einer Maxtrix Vektor Multiplikation
// Version 3
/*
(  a  b  c )     ( x )
(  d  e  f )  *  ( y )
(  g  h  i )     ( z )
*/

/* 
Verfahren:
Client 1:  Spalte (a,d,g)
Client 2:  Spalte (b,e,h)
Client 3:  Spalte (c,f,i)

Faktor:
Client 1:  x
Client 2:  y
Client 3:  z
*/

// Sendet jeweils eine Spalte an ein Client  UND dazu eine Zahl des Vector b

// Version bergibt jeweils eine Spalte an einem Client
// bertragung mit Send
// Version bergibt danach den Vektor b
// Erweiterung mit Broadcast


void main(int argc, char *argv[])
{
    int Pid, numprocs;
	int i;
	
	double l_mat_sp[MAX];
	double erg_spalte[MAX];  // Speichert Spalte*B(i)
	double FaktorB;
	double mat[MAX*MAX]= { 1,4,7,2,5,8,3,6,9 };
	double b[MAX];

		// nur von Root bentigt
	double G_erg[MAX];

	// Status
	MPI_Status status;
	
	MPI_Init(&argc,&argv);

	   // Anzahl der Prozesse
	MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
	if (numprocs != MAXCLIENT) {
		printf("Bitte immer %d Client definieren\n",MAXCLIENT);
		return;
	}
    
	   // meine eigene ID
	MPI_Comm_rank(MPI_COMM_WORLD,&Pid);

	// Root sendet Maxtrix spaltenweise, Sichtweise Original Matrix
	// Root sendet Vektor B, einzeln
	if (Pid  ==  root) {
		// Root rechnet NICHT !!
		b[0]= 10;	b[1]= 11;	b[2]= 12; // Init nur im Root
			// erg_spalte vom Root
		erg_spalte[0]=0.0;
		erg_spalte[1]=0.0;
		erg_spalte[2]=0.0;

			// spaltenweise
		MPI_Send( &mat[0], 3, MPI_DOUBLE, 1, 0, MPI_COMM_WORLD);
		MPI_Send( &mat[3], 3, MPI_DOUBLE, 2, 0, MPI_COMM_WORLD);
		MPI_Send( &mat[6], 3, MPI_DOUBLE, 3, 0, MPI_COMM_WORLD);
			// neu, sendet
		MPI_Send( &b[0], 1, MPI_DOUBLE, 1, 0, MPI_COMM_WORLD);
		MPI_Send( &b[1], 1, MPI_DOUBLE, 2, 0, MPI_COMM_WORLD);
		MPI_Send( &b[2], 1, MPI_DOUBLE, 3, 0, MPI_COMM_WORLD);

	}
	else {
		MPI_Recv( l_mat_sp, 3, MPI_DOUBLE, 
			root, 0, MPI_COMM_WORLD, &status);
			// neu, empfngt
		MPI_Recv( &FaktorB, 1, MPI_DOUBLE, 
			root, 0, MPI_COMM_WORLD, &status);
		printf("  Pid: %d    mat(0): %f   mat(1): %f   mat(2): %f    FaktorB %f\n",
				   Pid, l_mat_sp[0], l_mat_sp[1], l_mat_sp[2], FaktorB );
		// Multiplikation
		for (i=0; i<MAX; i++) {
			erg_spalte[i] = l_mat_sp[i]*FaktorB;
		}
			// Nun darf aber keine Summe bertragen werden
			// Alle drei Werte mssen bertragen werden
			// Reduce -Befehl
	}


		// hier werden VIER Client berechnet !!
	MPI_Reduce(erg_spalte, G_erg, MAX, MPI_DOUBLE, MPI_SUM, 
		    0, MPI_COMM_WORLD);

			
		  // nur Master gibt aus
    if (Pid == 0) {
		puts("");
		puts("Ergebnis:");
		for (i=0; i<MAX; i++) {
		  printf("Master: summe[%d] = %f\n", (i+1), G_erg[i]);
		}
	}
      

	MPI_Finalize();
}


/*

double TransportCosts[][cMkts] =
{ { 32.19, 47.29, 31.99, 19.11 },
  { 11.29, 22.49, 33.47, 17.29 },
  { 41.97, 22.09,  9.76, 22.55 }  };


*/