#include "mpi.h"
#include <stdio.h>
#include <math.h>
#include <stdlib.h>


#define MAXCLIENT 3
#define MAX 3
#define root 0

// Bitte immer DREI Tasks angeben

// Programm zur Berechnung einer Maxtrix Vektor Multiplikation
// Version 4
/*
(  a  b  c )     ( x )
(  d  e  f )  *  ( y )
(  g  h  i )     ( z )
*/

/* 
Verfahren:
Client 1:  Spalte (a,d,g)
Client 2:  Spalte (b,e,h)
Client 3:  Spalte (c,f,i)

Faktor:
Client 1:  x
Client 2:  y
Client 3:  z
*/

// Version bergibt jeweils eine Spalte an einem Client
// bertragung mit Scatter
// Version bergibt danach den Vektor b
// Erweiterung mit Scatter und Gather

// root rechnet mit

void main(int argc, char *argv[])
{
	int Pid, numprocs;
	int i;
	
	double l_mat_sp[MAX];
	double erg_spalte[MAX];  // Speichert Spalte*B(i)
	double FaktorB;
	double mat[MAX*MAX]= { 1,4,7,2,5,8,3,6,9 };
	double b[MAX];

		// nur von Root bentigt
	double G_erg[MAX];

	int     client_size;
	div_t   part;
	int		retcode;

	
	MPI_Init(&argc,&argv);

	   // Anzahl der Prozesse
	MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
	if (numprocs != MAXCLIENT) {
		printf("Bitte immer %d Client definieren\n",MAXCLIENT);
		return;
	}
    
	   // meine eigene ID
	MPI_Comm_rank(MPI_COMM_WORLD,&Pid);

	// Root sendet Maxtrix spaltenweise, Sichtweise Original Matrix
	// Root sendet Vektor B, einzeln
	part=div(MAX*MAX,MAXCLIENT);
	if (part.rem!=0) 
		client_size=part.quot+1;        
	else 
		client_size=part.quot;	

	if (Pid  ==  root) {
		b[0]= 10;	
		b[1]= 11;	
		b[2]= 12; // Einlesen und Init nur im Root
	}

	retcode = MPI_Scatter(mat, client_size, MPI_DOUBLE, 
				l_mat_sp, client_size, MPI_DOUBLE, 
				0, MPI_COMM_WORLD);
	if ( retcode!= MPI_SUCCESS) {
		puts("Fehler beim Aufruf von Scatter");
		return;
	}
		
	retcode = MPI_Scatter(b, 1, MPI_DOUBLE, 
				&FaktorB, 1, MPI_DOUBLE, 
				0, MPI_COMM_WORLD);
	if ( retcode!= MPI_SUCCESS) {
		puts("Fehler beim Aufruf von Scatter");
		return;
	}



	printf("  Pid: %d    mat(0): %f   mat(1): %f   mat(2): %f    FaktorB %f\n",
				   Pid, l_mat_sp[0], l_mat_sp[1], l_mat_sp[2], FaktorB );

	// Multiplikation
	for (i=0; i<MAX; i++) {
		erg_spalte[i] = l_mat_sp[i]*FaktorB;
	}

		// hier werden DREI Client berechnet !!
	MPI_Reduce(erg_spalte, G_erg, MAX, MPI_DOUBLE, MPI_SUM, 
		    0, MPI_COMM_WORLD);

			
		  // nur Master gibt aus
	if (Pid == 0) {
		puts("");
		puts("Ergebnis:");
		for (i=0; i<MAX; i++) {
		  printf("Master: summe[%d] = %f\n", (i+1), G_erg[i]);
		}
	}
      

	MPI_Finalize();
}


