#include "mpi.h"
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

// hier dynamische Felder

/*
 Version 4
 Aufteilen von 1 bis n auf     m Workers 
 Die Aufteilung wird ber ein zustzliches Feld realisiert
    siehe Feld    offset  und sendcounts
 
   MPI_Scatterv

 Nach der bermittlung wird eine Funktion ausgefhrt, add um 2
 und dann werden mittels der Gather-Anweisung die Daten wieder gesammelt
 MPI_Gatherv
*/



#define C_MAX 17

#define ROOT 0

// Scatter 4
int main(argc,argv)
int  argc;
char *argv[];
{
	int     root = 0;
    int     numprocs, Pid, i;
    int     x_root[C_MAX];
    int     y_root[C_MAX];
	int     client_size;
    

	int sendcounts[C_MAX]; // speichert die Lngen
	int offset[C_MAX]; // speichert die Anfangsadresse
	int rest;
	int summe;


	int retcode;
    
	int     x[C_MAX];
    int     y[C_MAX];

    if (MPI_Init(&argc,&argv)!=MPI_SUCCESS) {
		printf("MPI_Init failed.\n");
		return -1;
    }

    MPI_Comm_size(MPI_COMM_WORLD, &numprocs);
    MPI_Comm_rank(MPI_COMM_WORLD, &Pid);

    printf("Proc %d: I live.\n", Pid, numprocs);

	if (numprocs>C_MAX) {
		puts("Fehler, zu viele Prozesse");
	}


    if (Pid==0) {
		  // Daten im Master erzeugen
		for (i=0; i<C_MAX; i++) {
			x_root[i] = i+1;
		}
		puts("  ");
    }

	
    
	  // zur Kontrolle auf Null gesetzt, pro Client
	for (i=0; i<C_MAX; i++) {
		x[i] = 0;
	}

	   // Aufteilen der Felder
	client_size = C_MAX / numprocs;  // ganzzalig !!!

	for (i=0; i<C_MAX; i++) {
		sendcounts[ i ] = client_size;
	}

	  // gib es ein Rest
	rest = C_MAX  - numprocs*client_size;
	if (rest>0) {
		// es fehlen noch welche,  Aufsummieren vom Anfang
		for (i=0; i<rest; i++) {
			sendcounts[ i ] += 1;
		}
	}

	 // Berechne den Offset pro Client
	summe=0;
	for (i=0; i<C_MAX; i++) {
		offset[ i ] = summe;
		summe += sendcounts[ i ];
	}
	

	
	 // wartet auf alle Tasks
	MPI_Barrier(MPI_COMM_WORLD);


	if (Pid==0) {
		// Ausgabe der Bereiche, nur Master
		for (i=0; i<numprocs; i++) {
			printf("sendcounts %d  offset:  %d  \n",sendcounts[i], offset[i]);		
		}
		puts("  ");
		puts("  ");
		puts("Ausgabe der Eingangsdaten beim Master:");
		for (i=0; i<C_MAX; i++) {
			printf("i:  %d  x_root[i]: %d\n",i, x_root[i]);
		}
		puts("  ");
		puts("  ");
	}


	// Verteilen des Feldes
    retcode = MPI_Scatterv(x_root, sendcounts, offset, MPI_INT,     
		x, sendcounts[Pid],  MPI_INT, ROOT, MPI_COMM_WORLD);
	if ( retcode!= MPI_SUCCESS) {
		puts("Fehler beim Aufruf von Scatter");
	}

  
	puts("  ");
	puts("  ");
	puts("Ausgabe der Clientdaten:");

	  // zur Kontrolle ausgeben
	for (i=0; i<sendcounts[Pid]; i++) {
		printf("Pid %d  i:  %d  x[i]: %d\n",Pid, i, x[i]);		
	}


	 // Berechnen der Funktionen
	for (i=0; i<sendcounts[Pid]; i++) {
		y[i] = x[i] + 2;
	}

    
//	MPI_Barrier(MPI_COMM_WORLD);


   
      // Sammeln der Daten
    retcode = MPI_Gatherv(y, sendcounts[Pid], MPI_INT,  
		y_root, sendcounts,  offset, MPI_INT, 
		ROOT, MPI_COMM_WORLD);
	if ( retcode!= MPI_SUCCESS) {
		puts("Fehler beim Aufruf von Gather");
	}


      // Ausgabe der Ergebnisse
	if (Pid == 0 ) {
		puts("  ");
		puts("  ");
		puts("Ausgabe der Ergebnisse:");
		for (i=0; i<C_MAX; i++) {
			printf("i:  %d  y_root[i]: %d\n", i, y_root[i]);
		}
		puts("  ");
		puts("  ");
	}


    MPI_Finalize();
	return 0;
}  // main


